<?
require_once 'rss_fetch.inc';
require_once 'rss_fetch_c3.inc'; // for fetch_rss_with_pass

require_once 'c3_config.php';


function authentication($auth_file){
  if( file_exists($auth_file) ){
    include($auth_file);

    //Basicǧ===============
    if(!isset($_SERVER['PHP_AUTH_USER']) || !( ($_SERVER['PHP_AUTH_USER'] == $login['user']) && ( crypt($_SERVER['PHP_AUTH_PW'], $login['pass']) == $login['pass']) ) ) {
      header('WWW-Authenticate: Basic realm="c3 login"');
      header('HTTP/1.0 401 Unauthorized');
    echo '<meta http-equiv="content-type" content="text/html; charset=EUC-JP">';
      echo 'Login Failed. 桼ǧڤɬפǤ';
      exit;
    }

  } else {
    echo '<meta http-equiv="content-type" content="text/html; charset=EUC-JP">';
    exit;
  }

}
  
function delete_rss($file, $del_key){
  $tmp_file = "./data/c3_tmp_file";

  $fp = fopen($file, "r");
  $tmp = fopen($tmp_file, "w");

  $buf = explode("@", $del_key);
  $url = $buf[0];
  $cat = $buf[1];
  $num = $buf[2];

  while ($data = fgetcsv($fp, 10000)) {
    $url_from_file = $data[1];
    $cat_from_file = $data[2];
    $num_from_file = $data[3];

    if ((strcmp($url,$url_from_file) == 0) &&
	(strcmp($cat,$cat_from_file) == 0) &&
	(strcmp($num,$num_from_file) == 0)){
      continue;
    } else{
      $line = '"'.$data[0].'","'.$data[1].'","'.$data[2].'","'.$data[3].'"';
      fputs($tmp, $line."\n");
    }
  }

  fclose($fp); 
  fclose($tmp);
  copy($tmp_file, $file);
  unlink($tmp_file);
}

function read_rss_list ($file){
  $rss_list = array();
  
  $fp = fopen($file, "r");

  while ($data = fgetcsv($fp, 10000)) {
    if (!isset($data[0]))// skip blank line.
	continue;

    $one = array($data[0],$data[1],$data[2],$data[3],$data[4],$data[5]);
    array_push($rss_list, $one);
  }
  
  fclose($fp);

  return $rss_list;
}


function get_category_list($file){
  $category_list = array();
  $fp = fopen($file, "r");

  while ($data = fgetcsv($fp, 10000)) {
    if (!isset($data[0]))// skip blank line.
	continue;
    
    array_push($category_list, $data[0]);
  }
  fclose($fp);

  return array_unique ($category_list);
}

function delete_category($file, $cat){
  $tmp_file = "./data/c3_tmp_file";

  $fp = fopen($file, "r");
  $tmp = fopen($tmp_file, "w");

  while ($data = fgetcsv($fp, 10000)) {
    $cat_from_file = $data[0];
    if (strcmp($cat, $cat_from_file) == 0) {
      continue;
    } else{
      $line = '"'.$data[0].'"';
      fputs($tmp, $line."\n");
    }
  }

  fclose($fp); 
  fclose($tmp);
  copy($tmp_file, $file);
  unlink($tmp_file);

  // 
  // Move RSS from deleted category to "unregisterd" category.
  // 

  $tmp_file = "./data/c3_tmp_file";

  $fp = fopen("./data/c3_category_list.csv", "r");
  $tmp = fopen($tmp_file, "w");
  //$category_list_file = "./data/c3_category_list.csv";

  while ($data = fgetcsv($fp, 10000)) {
    if (!isset($data[0]))// skip blank line.
	continue;

    if (strcmp($data[2], $cat) == 0){
      $data[2] = "̤Ͽ";
    }
    $line = '"'.$data[0].'","'.$data[1].'","'.$data[2].'","'.$data[3].'"';
    fputs($tmp, $line."\n");
  }
  
  fclose($fp); 
  fclose($tmp);
  copy($tmp_file, $file);
  unlink($tmp_file);

}


function get_c3_css(){


}

function read_RSS_storage($file){
  $url_list = array();
  
  $fp = fopen($file, "r");

  while ($data = fgetcsv($fp, 10000)) {
    if (!isset($data[0]))// skip blank line.
	continue;

    $one = array($data[0],$data[1],$data[2]);
    array_push($url_list, $one);
  }
  
  fclose($fp);

  return $url_list;
}

function add_RSS_to_storage($file,$url,$title){
  $date = date("Y/m/d"); // Caution!! This function depends LOCALE.
  
  $line = '"'.$title.'","'.$url.'","'.$date.'"';

  $fp = fopen($file, "a");
  fputs($fp, $line."\n");

  fclose($fp);
}

function delete_RSS_from_storage($file,$url){
  $tmp_file = "./data/c3_tmp_file";

  $fp = fopen($file, "r");
  $tmp = fopen($tmp_file, "w");

  while ($data = fgetcsv($fp, 10000)) {
    $url_from_file = $data[1];
    if (strcmp($url, $url_from_file) == 0) { // Match!
      continue;
    } else{
      $line = '"'.$data[0].'","'.$data[1].'","'.$data[2].'"';
      fputs($tmp, $line."\n");
    }
  }

  fclose($fp); 
  fclose($tmp);
  copy($tmp_file, $file);
  unlink($tmp_file);
}



class RSS_entry{
  var $url;
  var $title;
  var $rss;
  var $num=3;

  var $pass;
  var $user;
  var $auth_required = FALSE;
  
  function RSS_entry($url,$num){
    $this->url = $url;
    $this->num = $num;
  }
  
  function set_pass($user, $pass){
    $this->user = $user;
    $this->pass = $pass;
    $this->auth_required = TRUE;
  }
  
  function fetch_RSS(){
    if ($this->auth_required == TRUE){
      $this->rss = fetch_rss_with_pass($this->url, $this->user, $this->pass);
    }else{
      $this->rss = fetch_rss($this->url);
    }

    $this->title = $this->rss->channel['title'];
    $this->title = mb_convert_encoding($this->title, "EUC-JP", "auto");
  }
  
  function show_title(){
    if ($this->auth_required == TRUE)
      $title = $this->title . "  (Basic Auth Required)";
    else 
      $title = $this->title;

    echo "<h4>$title</h4>\n";
  }
  
  function show_links(){
    echo "<ul>\n";
    $counter =0;
    foreach ($this->rss->items as $item ) {
      if ($counter == $this->num) break;

      $title = $item[title];
      $title = mb_convert_encoding($title, "EUC-JP", "auto");
      $url = $item[link];
      //      $date = $item[dc][date];
      echo '<li><a href="'.$url.'" target="_top">'.$title.'</a>';

      //      echo '<font color="yellow"><a href="storage.php?url='
      //	.$url.'&title='.$title.'">storage˲ä</a></font>';

      echo '<form method="post" action="storage.php">';
      echo '<input type="hidden" name="url" value="'.$url.'" />';
      echo '<input type="hidden" name="title" value="'.$title.'" />';
      echo '<input name="sadd" value="add" type="submit" />';
      echo '</form>';

      echo '</li>';
      $counter++;

    }
    echo "</ul>\n";
  }
}

?>